package com.fdkankan.platform.user.factory.impl;

import com.alibaba.fastjson.JSONObject;
import com.fdkankan.common.constant.Constant;
import com.fdkankan.common.constant.ErrorCode;
import com.fdkankan.common.exception.BusinessException;
import com.fdkankan.platform.order.entity.VirtualOrder;
import com.fdkankan.platform.order.request.RequestPlaceOrder;
import com.fdkankan.platform.order.service.IVirtualOrderService;
import com.fdkankan.platform.order.service.PayOrderService;
import com.fdkankan.platform.user.factory.Recharge;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Component;

import java.math.BigDecimal;

@Component
public class WechatRecharge implements Recharge {

    @Autowired
    private PayOrderService payOrderService;
    @Autowired
    private IVirtualOrderService virtualOrderService;

    @Override
    public JSONObject scanPay(RequestPlaceOrder order) throws Exception {
        VirtualOrder virtualOrderEntity = virtualOrderService.getById(order.getOrderId());
        if (virtualOrderEntity == null){
            throw new BusinessException(ErrorCode.FAILURE_CODE_8001);
        }
        String subject = Constant.PAY_SUBJECT + "：" + virtualOrderEntity.getPoints();
        BigDecimal totalFee = new BigDecimal(virtualOrderEntity.getPoints()).multiply(new BigDecimal(100));
        String orderSn = virtualOrderEntity.getOrderSn();
        orderSn += "_recharge";
        return payOrderService.wechatScanPay(orderSn, subject, subject, totalFee);
    }

    @Override
    public JSONObject h5Pay(RequestPlaceOrder order, String ip) throws Exception {
        VirtualOrder virtualOrderEntity = virtualOrderService.getById(order.getOrderId());
        if (virtualOrderEntity == null){
            throw new BusinessException(ErrorCode.FAILURE_CODE_8001);
        }
        String subject = Constant.PAY_SUBJECT + "：" + virtualOrderEntity.getPoints();
        BigDecimal totalFee = new BigDecimal(virtualOrderEntity.getPoints()).multiply(new BigDecimal(100));
        String orderSn = virtualOrderEntity.getOrderSn();
        orderSn += "_recharge";
        return payOrderService.wechatH5Pay(orderSn, subject, subject, totalFee, ip);
    }

    @Override
    public String getType() {
        return "wechat_1";
    }
}
